﻿var questions = [{
    question: "&iquest;D&oacute;nde est&aacute;n las instrucciones sobre Menciones de Responsabilidad (MDR)?",
    choices: ["1.7 de RDA", "19.2 de RDA", "2.4 de RDA"],
    correctAnswer: 2
}, {
    question: "&iquest;Cu&aacute;l de las siguientes declaraciones establece m&aacute;s exactamente los elementos n&uacute;cleo de la MDR en RDA?",
    choices: ["Todas las MDR relacionadas con la portada son n&uacute;cleo", "La primer MDR relacionada con la portada es n&uacute;cleo; las otras son opcionales", "De acuerdo a tu juicio, pod&eacute;s decidir incluso no registrar cualquier MDR que aparezca en la fuente "],
    correctAnswer: 1
}, {
    question: "&iquest;Verdadero o Falso?</br>Una LC-PCC PS desalienta registrar MDR adicionales m&aacute;s all&aacute; de los requisitos n&uacute;cleo",
    choices: ["Verdadero -- siempre", "Verdadero -- aunque la PS incluye la leyenda &quot;si&quot;", "Falso"],
    correctAnswer: 2
}, {
    question: "&iquest;Cu&aacute;l de las siguientes declaraciones establece mejor como determinar si <em><u>una</u></em> menci&oacute;n constituye una MDR o <em><u>m&uacute;ltiples</u></em> MDR?",
    choices: ["Si las entidades est&aacute;n gramaticalmente vinculadas, consideralas como <em><u>una</u></em> MDR", "Si las entidades llevan a cabo diferentes funciones, consideralas como <em><u>m&uacute;ltiples</u></em> menciones", "Fundamenta tu decisi&oacute;n solamente en la puntuaci&oacute;n que aparece en el recurso"],
    correctAnswer: 0
}, {
    question: "&iquest;Qu&eacute; deber&iacute;as hacer si quer&eacute;s aclarar el rol de una entidad responsable, y dicha menci&oacute;n no aparece en la portada?",
    choices: ["Pod&eacute;s trascribir solo la MDR tal como aparece, sin suministrar una aclaraci&oacute;n adicional", "Deber&iacute;as agregar una aclaraci&oacute;n -- entre corchetes -- en el campo 245", "Deber&iacute;as agregar la aclaraci&oacute;n al final de la MDR trascrita"],
    correctAnswer: 1
}, {
    question: "&iquest;Cu&aacute;l de las siguientes declaraciones acerca de MDR es <em><u>m&aacute;s</u></em> exacta?",
    choices: ["Generalmente, no pod&eacute;s omitir nombres ni afiliaciones acad&eacute;micas", "Nunca pod&eacute;s omitir nombres de entidades, pero pod&eacute;s omitir afiliaciones", "Pod&eacute;s omitir nombres de autores, pero no sus afiliaciones o grados acad&eacute;micos"],
    correctAnswer: 0
}, {
    question: "Si decid&iacute;s -- como una excepci&oacute;n -- omitir los nombres en una MDR, &iquest;Qu&eacute; m&aacute;s deb&eacute;s hacer? ",
    choices: ["No necesitas hacer nada m&aacute;s; simplemente omitir los nombres de acuerdo a tu juicio", "Reemplazar lo que ha sido omitido con &quot;... [et al.].&quot;", "Agregar un resumen entre corchetes de la omisi&oacute;n, por ej., &quot; ... [y otros quince]&quot;"],
    correctAnswer: 2
}, {
    question: "La portada incluye una MDR nombrando al autor, y una segunda nombrando al ilustrador. &iquest;Cu&aacute;l de las siguientes declaraciones es verdadera? ",
    choices: ["Deb&eacute;s registrar la primera MDR, pero no necesariamente la segunda", "Deb&eacute;s registrar ambas MDR", "Pod&eacute;s registrar cualquier MDR, siendo m&aacute;s &uacute;til para proveer 'cr&eacute;dito' a los puntos de acceso"],
    correctAnswer: 0
}, {
    question: "La portada incluye esta MDR: </br>&quot;...written by Kate James, University of Virginia, Charlottesville, Virginia&quot;</br> &iquest;Cu&aacute;l de las siguientes declaraciones es correcta?",
    choices: ["Pod&eacute;s omitir &quot;written by&quot;", "Pod&eacute;s omitir la afiliaci&oacute;n del autor", "Pod&eacute;s omitir la menci&oacute;n entera porque no es n&uacute;cleo", "No pod&eacute;s omitir ninguna porci&oacute;n de la menci&oacute;n de responsabilidad"],
    correctAnswer: 1
}, {
    question: "Si decid&iacute;s omitir los nombres o resumir otros elementos en una MDR, deber&iacute;as basar esta decisi&oacute;n, principalmente, sobre...",
    choices: ["Las pautas claras que se proveen en 2.4.1.4 y 2.4.1.5 de LC-PCC PS", "La consideraci&oacute;n de las Tareas del Usuario de FRBR", "La estimaci&oacute;n de cu&aacute;nto tiempo te ahorrar&iacute;as"],
    correctAnswer: 1
}, ];

var currentQuestion = 0;
var correctAnswers = 0;
var quizOver = false;
var answer = true;

$(window).load(function () {
	if($("html").height()<$(window).height()) {
		$("footer").addClass("fixed");
	} else {
		$("footer").removeClass("fixed");
	}
});

$(document).ready(function () {

    displayCurrentQuestion();
    $(this).find(".quizMessage").hide();

    $(this).find(".nextButton").on("click", function () {
        if (!quizOver) {
			var continuar = true;

            value = $("input[type='radio']:checked").val();

            if (value == undefined) {
                $(document).find(".quizMessage").text("Por favor, selecciona una respuesta");
                $(document).find(".quizMessage").show();
            } else {
                $(document).find(".quizMessage").hide();
				
                if (value == questions[currentQuestion].correctAnswer) {
                    correctAnswers++;
					answer = true;
					$(document).find(".quizMessage").html("<div class='quizMessageOK'><img src='Check-128.png'> Respuesta correcta</div>");
                    $(document).find(".quizMessage").show();
                } else {
					answer = false;
					$(document).find(".quizMessage").html("<div class='quizMessageError'><img src='Close-128.png'> Respuesta incorrecta</div>");
                    $(document).find(".quizMessage").show();
					if(currentQuestion == 3) {
						if (value == 1) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Si las entidades están gramaticalmente vinculadas, no importa si ellas llevan a cabo la misma función.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Tanto la puntuación como la redacción son factores para determinar si las entidades están \"vinculadas\" en una única mención.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 4) {
						if (value == 0) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Podés agregar una aclaración, pero debés registrarla entre corchetes.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! A partir de que la aclaración no aparece en la portada, no podés agregarla sin paréntesis.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 5) {
						if (value == 0) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Esto es generalmente verdadero.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 1) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Podés ocasionalmente usar tu juicio para omitir cualquiera de estos dos elementos.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Podés ocasionalmente usar tu juicio para omitir cualquiera de estos dos elementos.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 6) {
						if (value == 0) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Debés resumir lo que ha sido omitido.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 1) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Este fue el procedimiento correcto bajo AACR2.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 7) {
						if (value == 1) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Solo la primer MDR relacionada con el título propiamente dicho es núcleo. Podés registrar la segunda, aunque no es requerida.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! La primer MDR es núcleo y debe ser registrada. Podés registrar la segunda si lo deseas, aunque esta decisión es independiente de la elección de que puntos de acceso proveer.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 8) {
						if (value == 0) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! La MDR debe ser transcrita exactamente tal como aparece, y las omisiones se permiten solo si no se pierde información esencial.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! La primer MDR es núcleo y debe transcribirse exactamente tal como aparece.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
						if (value == 3) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Este es el principio básico, que refuerza 2.4.1.5 de LC-PCC PS, sosteniendo \"generalmente\" no resumir una MDR. No obstante, excepcionalmente, podés omitir los datos como títulos, grados y afiliaciones si estas son gravosas.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									displayCurrentQuestion();
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									newQuestion = currentQuestion + 1;
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
					if(currentQuestion == 9) {
						if (value == 0) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Esta PS es general por naturaleza y no es completa. Usa tu juicio en el contexto de las Tareas del Usuario de FRBR.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
								}
							});
						}
						if (value == 2) {
							continuar = false;
							$.msgBox({ 
								type: "confirm",
								title: "Aviso",
								content: "Incorrecto! Aunque la economía y la productividad pueden ser factores válidos, ellas deben considerarse en el contexto de las Tareas del Usuario de FRBR.",
								buttons: [{ value: "Aceptar" }],
								beforeShow: function (result) {
									$(document).find(".nextButton").hide();
									$(document).find(".backButton").hide();
								},
								success: function (result) {	
									setTimeout(function() {
									$(document).find(".nextButton").show();
									$(document).find(".backButton").show();
									$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
									$(document).find(".quizMessage").hide();
									}, 1500);
								}
							});
						}
					}
				}	

                currentQuestion++;

                if (currentQuestion < 10) {
					
					if(continuar == true) {
						
						setTimeout(function() {
						displayCurrentQuestion();
						$(document).find(".nextButton").show();
						$(document).find(".backButton").show();
						newQuestion = currentQuestion + 1;
						$(document).find("#status").text("Pregunta " + newQuestion + " de 10");
						$(document).find(".quizMessage").hide();
						}, 1500);
						$(document).find(".nextButton").hide();
						$(document).find(".backButton").hide();
						
					}
					
                } else {
					
                    displayScore();
                    $(document).find(".nextButton").text("Comenzar Nuevamente");
                    quizOver = true;
					
                }
            }
        } else {
            quizOver = false;
			$(document).find(".quizMessage").hide();
            $(document).find(".nextButton").text("Siguiente");
            resetQuiz();
            displayCurrentQuestion();
            hideScore();
			$(document).find("#status").text("Pregunta 1 de 10");    
        }

    });
	
	$(this).find(".backButton").on("click", function () {
		currentQuestion = currentQuestion - 1;
		displayCurrentQuestion()
		if (answer == true) {
			correctAnswers = correctAnswers - 1;
		}
		if (currentQuestion == 9) {
			quizOver = false;
			$(document).find(".quizMessage").hide();
            $(document).find(".nextButton").text("Siguiente");
			hideScore();
		}
	});

});

function displayCurrentQuestion() {

    var question = questions[currentQuestion].question;
    var questionClass = $(document).find(".quizContainer > .question");
    var choiceList = $(document).find(".quizContainer > .choiceList");
    var numChoices = questions[currentQuestion].choices.length;
	
	$(document).find("#status").text("Pregunta " + (currentQuestion + 1) + " de 10");
	
	if(currentQuestion == 0) {
		$(document).find(".backButton").hide();
	} else {
		$(document).find(".backButton").show();
	}

    $(questionClass).html(question);

    $(choiceList).find("li").remove();

    var choice;
    for (i = 0; i < numChoices; i++) {
        choice = questions[currentQuestion].choices[i];
        $('<li><input type="radio" value=' + i + ' name="dynradio" /><label>' + choice + '</label></li>').appendTo(choiceList);
    }

  $('#quiz li').click(function() {
	var index = $(this).index();
	$('#quiz input:radio').eq(index).prop('checked', true);
  });

}

function resetQuiz() {
    currentQuestion = 0;
    correctAnswers = 0;
    hideScore();
}

function displayScore() {
    var percentage = (correctAnswers * 100) / questions.length;
    percentage = Math.round(percentage);
    $(document).find(".quizContainer > .result").html("<hr /><br/><span style='font-weight: bolder; font-size: 20px'>Gracias por realizar el examen: Juicio del Catalogador y la Mención de Responsabilidad</span><br /><br />Usted respondi&oacute; correctamente <strong>" + correctAnswers + "</strong> de <strong>" + questions.length + "</strong> preguntas.<br /><br />Su porcentaje de precisi&oacute;n es <strong>" + percentage + "%</strong> <br /><br />Si su calificaci&oacute;n es del <strong>80% o superior</strong>, ha comprendido el curso.<br /><br />");
    $(document).find(".quizContainer > .result").show();
    $(window).scrollTop($('.result').offset().top);
}

function hideScore() {
    $(document).find(".result").hide();
}